float encode2x8(in vec2 toEnc) {
  
    uvec2 bitfield = uvec2(toEnc * 255.0 + 0.5);

    return float(bitfield.x | bitfield.y << 8u) / 65535.0;
}

vec2 decode2x8(in float toDec) {

    uint bitfield = uint(toDec * 65535.0);

    return vec2(bitfield & 255u, bitfield >> 8u) / 255.0;
}