#if ShadowType == 2
    #include "pcss.glsl"
#elif ShadowType == 1
    #include "soft.glsl"
#elif ShadowType == 0
    #include "hard.glsl"
#endif

vec3 calculate_shadow_map(in vec3 in_position, in bool is_foliage) {
    #if ShadowType == 0
        return hard_shadows_subsurface_scattering(in_position, is_foliage);
    #elif ShadowType == 1
        return soft_shadows_subsurface_scattering(in_position, is_foliage);
    #elif ShadowType == 2
        return pcss_subsurface_scattering(in_position, is_foliage);
    #endif
}