/* DRAWBUFFERS:0 */
layout(location = 0) out vec3 out_lens;

//Obvious what this is for.
//Currently not actually used.

#include "/lib/important.glsl"

//Samplers
uniform sampler2D colortex0;
uniform sampler2D colortex6;
uniform sampler2D colortex7;
uniform sampler2D depthtex0;
uniform sampler2D depthtex1;
uniform sampler2D noisetex;

//Uniforms
uniform mat4 gbufferProjection, gbufferProjectionInverse;
uniform mat4 gbufferModelViewInverse;
uniform mat4 gbufferPreviousModelView, gbufferPreviousProjection;

uniform vec3 sunPosition, cameraPosition, previousCameraPosition;

uniform vec2 view_pixel_size, view_size, taa_offset;

uniform float frameTimeCounter, aspectRatio, centerDepthSmooth;

uniform int isEyeInWater;

//Fragment inputs
in vec2 texture_coordinate;

#include "/lib/converters/converters.glsl"
#include "/lib/color/tonemapping.glsl"
#include "/lib/fragment/lens_misc.glsl"

void main() {
    out_lens = texture(colortex0, texture_coordinate).rgb;
}