const vec3 lumacoeff_rec709 = vec3(0.2125, 0.7154, 0.0721);

const float pi = radians(180.0);
const float tau = radians(360.0);
const float rpi = 1./acos(-1.);
const float hpi = acos(0.);
const float phi = sqrt(5.) * .5 + .5;
const float pi4 = 12.5663706;
const float pidiv2 = pi * 0.5;
const float goldenAngle = tau / (phi + 1.0);
const float sunPathRotation = -40.0;

const mat2 rotateGoldenAngle = mat2(cos(goldenAngle), -sin(goldenAngle), sin(goldenAngle), cos(goldenAngle));

const int shadowMapResolution = 2048;
const int noiseTextureResolution = 64;

const vec2 bokeh_offset = vec2(0.5);

const float sun_radius = 1.25 * radians(0.545);

const int MaxColorRange = 1000;